#include<stdio.h>
#include<string.h>
#include<math.h>

#define MIN_TIME_INTERVAL 0.10000000

//// function to store 10 minimum skip distances and their response times, in order to get data.

struct _data{
	int write_size;
	float thinktime;
	int skipdists[1000];
	double responsetimes[1000];
	int count;
	double min;
	int minskip;
} data[15000];

int current_data_size = 0;

void insertmin(struct _data * d,int skipdistance,double responsetime){
	int i;
//	printf(" inserting \n");	
	for(i=0; i < d->count; i ++){
		if(responsetime < d->responsetimes[i]){

			/// need to enter this 
			//d->count ++;
			int j;
			if(d->count < 10)
				d->count ++;
			
			j = d->count - 1;
				
			for(; j > i;j--){
				d->skipdists[j] = d->skipdists[j-1];
				d->responsetimes[j] = d->responsetimes[j-1];
			}
			 d->skipdists[i] = skipdistance;
		         d->responsetimes[i] = responsetime;
   
			return;
		}

	}
	
	// we have up to 10 entries
	if(d->count < 10){
		d->skipdists[d->count] = skipdistance;
		d->responsetimes[d->count] = responsetime;
		d->count ++;
	}
}

void insert(struct _data *d, int skipdistance,double responsetime){

if(responsetime < d->min){
	d->min = responsetime;
	d->minskip = skipdistance;
}

d->skipdists[d->count] = skipdistance;
d->responsetimes[d->count]=responsetime;
d->count ++;
}

void insertdata(int write_size,float thinktime, int skipdistance, double responsetime){
	int i;
	for( i = 0 ; i < current_data_size; i ++) {
		if(data[i].write_size == write_size && data[i].thinktime == thinktime){
			/// we need to insert this depending on the response time.
			//insertmin(&data[i],skipdistance,responsetime);
			insert(&data[i],skipdistance,responsetime);
			return;
		}
	}
	/// first insertiuon 
	data[current_data_size].write_size = write_size;
	data[current_data_size].thinktime = thinktime;
	data[current_data_size].skipdists[0] = skipdistance;
	data[current_data_size].responsetimes[0] = responsetime;
	data[current_data_size].count = 1;
	data[current_data_size].min = responsetime;
	data[current_data_size].minskip = skipdistance;
	current_data_size ++;
}


int equalfloat(float r1,float r2){

 if( fabsf(r1 -r2) < 0.001)
	return 1;
 else
	return 0;

}


double getResponseTime(int write_size,float thinktime,int skipdistance){
	int i;
	for(i = 0; i < current_data_size; i ++){
		if(data[i].write_size == write_size && fabs(data[i].thinktime - thinktime)<0.001){
			/// find the response time for given skipdistance.. or closest skip distance.
			int j;
			for(j = 0; j < data[i].count; j ++){
				if(data[i].skipdists[j] >= skipdistance){
					
					return data[i].responsetimes[j]; /// that is the skip distance
				}
			}
		}


	}
	//printf(" gadbad  %d %d %f \n",write_size,skipdistance,thinktime);
	return -1;

}


double getminResponseTime(int write_size,float thinktime){
	int i;
	for(i = 0 ; i < current_data_size; i ++){
		if(data[i].write_size == write_size && fabs(data[i].thinktime - thinktime)<0.001)
			return data[i].min;
	}
	return -1;

}

struct _compressed_data_1{
  int write_size;
  float think_begin;
  float think_end;
  int start_skip;
  int end_skip;	
  float avg_response_time;
} compressed_data[15000];

struct _curve_data{
 int write_size;
 float think_begin;
 float think_end;
 int skip_begin;
 int skip_end;
 float thinks[100];
 float skips[100];
 int numpoints;
 float m;
 float c;
 

} curve_data[10000];
int curve_data_count;


int compressed_data_count;

void printdata(){
  int i ;
  for(i = 0 ; i < current_data_size ; i ++){
	printf("%f,%d,%f\n",data[i].thinktime, data[i].minskip,data[i].min);
   }

}

void printcompressed_data(){
 int i;
 for(i = 0; i < compressed_data_count; i ++){

   printf("%d %f %f %d %d\n",compressed_data[i].write_size,compressed_data[i].think_begin,compressed_data[i].think_end,compressed_data[i].start_skip,compressed_data[i].end_skip); 

 }

}


void coarseDataAnalysis(){

  int i;
  int j = 0;
  for(i = 3; i < current_data_size; i = i + 4){

    float m = (data[i].minskip - data[j].minskip)/(data[i].thinktime - data[j].thinktime);
    float c= data[i].minskip - m * data[i].thinktime;

    for(; j <= i; j ++){
		
	   float estimated_response_time;
           int estimated_skip  = m * data[j].thinktime + c;
	   estimated_response_time = getResponseTime(4,data[j].thinktime,estimated_skip); 
	   printf("%f,%f,%f\n",data[j].thinktime,estimated_response_time,data[j].min);
	}

 }




}


/*int isFit(float m, float c, float tolerance, float thinks[], int skips[], int numpoints){

  int i;
  for(i = 0; i < numpoints; i ++){
	int skip = (int)(m * thinks[i] + c);
	float r1 = getResponseTime(4,thinks[i],skip);
        float r2 = getResponseTime(4,thinks[i],skips[i]);
        if(fabs(r1-r2) > tolerance)
		return 0;        

  }
  return 1;
}
*/

/*void fitcurve(float tolerance){

 int i,j;

 curve_data_count = 0;
 curve_data[0].think_begin = data[0].thinktime;
 curve_data[0].think_end = -1;
 curve_data[0].write_size = 4;
 curve_data[0].skip_begin = data[0].minskip;
 curve_data[0].thinks[0] = data[0].thinktime;
 curve_data[0].skips[0] = data[0].minskip;
 curve_data[0].numpoints = 1;
 /// all requests are of size 4 only.
 for(i = 1; i < current_data_size; i ++){
     if(curve_data[curve_data_count].think_end == -1){
		//// fit the curve for first time.
		curve_data[curve_data_count].think_end = data[i].thinktime;
		curve_data[curve_data_count].skip_end = data[i].minskip;
		curve_data[curve_data_count].m = (curve_data[curve_data_count].skip_end - curve_data[curve_data_count].skip_begin)/(curve_data[curve_data_count].think_begin - curve_data[curve_data_count].think_end);
		curve_data[curve_data_count].c = curve_data[curve_data_count].skip_begin - ( curve_data[curve_data_count].m * curve_data[curve_data_count].think_begin);
		int npts = curve_data[curve_data_count].numpoints;
		curve_data[curve_data_count].thinks[npts] = data[i].thinktime;
		curve_data[curve_data_count].skips[npts] = data[i].minskip;
		cuve_data[curve_data_count].numpoints ++;

	} else {
                
		float m = ( data[i].minskip - curve_data[curve_data_count].skip_begin) / (data[i].thinktime - curve_data[curve_data_count].think_begin);

                float c = curve_data[curve_data_count].skip_begin - ( curve_data[curve_data_count].m * curve_data[curve_data_count].think_begin);
                

		//if(fabs(responsetime - data[i].min) < tolerance){
		if(isFit(m,c,tolerance,curve_data[curve_data

			/// cool .. fits the curve and inside tolerance. :)
			curve_data[curve_data_count].think_end = data[i].thinktime;
		} else{
			/// this does not fit curve.. start with another line.
			curve_data_count ++;
			curve_data[curve_data_count].write_size = 4;
			curve_data[curve_data_count].think_begin= data[i].thinktime;
			curve_data[curve_data_count].think_end = -1; 
			curve_data[curve_data_count].skip_begin = data[i].minskip;
		} 


	}	
	

 }
 ///// fit curve completed
 printf(" Drew lines %d for this plot \n",curve_data_count);
 for( i = 0 ; i <= curve_data_count; i ++){
   printf("%f %f %f %f\n",curve_data[i].think_begin, curve_data[i].think_end,curve_data[i].m, curve_data[i].c);

  }

}
*/


void analyzecompressed_data(){
  int i;
  float C = 0.60;
  int L = 6;

 float our_m1 = (480-32)/6.7;
 float our_c1 = 32;
 float low_th1 = 0;
 float up_th1 = 6.7;

 float our_m2 = 0;
 float our_c2 = 0;
 float low_th2 = 6.8;
 float up_th2 = 8;
 
 int tot_count = 0;
 
 double sum_deviation= 0;
	
  for(i = 0; i <= compressed_data_count; i ++){
	int skip_distance;
	int write_size;
	write_size = compressed_data[i].write_size;
	skip_distance = (compressed_data[i].start_skip + compressed_data[i].end_skip)/2;
	if(compressed_data[i].think_begin == compressed_data[i].think_end){

			//int predicted_skip = (C + compressed_data[i].think_begin ) * L;
//			predicted_skip = predicted_skip % L;


			//float predicted_response_time = getResponseTime(write_size,compressed_data[i].think_begin,predicted_skip);	
                        float th = compressed_data[i].think_begin -((int)floorf(compressed_data[i].think_begin/up_th2)) * up_th2;
                        int our_skip;
			if(th > up_th1)
				our_skip = our_m2 * th + our_c2;
                        	//our_skip = 0.1509 * th * th + 66.979 * th + 30.227;
			else
				//our_skip = our_m1 * th + our_c1;
                        	our_skip = 0.1509 * th * th + 66.979 * th + 30.227;
 			//printf(" skip %d th %f \n",our_skip,th);

			float our_predicted_response_time = getResponseTime(write_size,compressed_data[i].think_begin,our_skip);
			//printf("%f,%f,%f\n",compressed_data[i].think_begin,our_predicted_response_time,getminResponseTime(write_size,compressed_data[i].think_begin));
       
                        double min_resp_time = getminResponseTime(write_size,compressed_data[i].think_begin);
                        double compress_resp_time = getResponseTime(write_size,compressed_data[i].think_begin,skip_distance);

			printf("%f,%f,%f\n",compressed_data[i].think_begin,getminResponseTime(write_size,compressed_data[i].think_begin),getResponseTime(write_size,compressed_data[i].think_begin,skip_distance));                 
//			
			tot_count ++;
                        sum_deviation +=  (compress_resp_time - min_resp_time) ;
//			printf("%f\n",compressed_data[i].think_begin);

//			printf("%f\n",getminResponseTime(write_size,compressed_data[i].think_begin));
//			printf("%f\n",getResponseTime(write_size,compressed_data[i].think_begin,skip_distance));
//			printf("%f\n",predicted_response_time);
//			printf(" For request size: %d and think time %f, actual min time %f and our time %f \n",write_size,compressed_data[i].think_begin,getminResponseTime(write_size,compressed_data[i].think_begin),getResponseTime(write_size,compressed_data[i].think_begin,skip_distance));
//			printf(" Predicted skip: %d  Response time : %f\n",predicted_skip,predicted_response_time);

	} else{
		float j;
//		float k = (compressed_data[i].end_skip - compressed_data[i].start_skip)/(compressed_data[i].think_end-compressed_data[i].think_begin);
//		float c = compressed_data[i].start_skip - k * compressed_data[i].think_begin;
		for( j = compressed_data[i].think_begin; j <= compressed_data[i].think_end; j= j + MIN_TIME_INTERVAL) {
			/// for each write and think time.. find what compression gives and what actual gives.
//		        skip_distance = (int)(j * k + c);
			skip_distance = compressed_data[i].start_skip;
			 //float predicted_response_time = getResponseTime(write_size,j,predicted_skip);
                        float th = j -((int)floorf(j/up_th2)) * up_th2;
                        int our_skip;
                        if(th > up_th1)
                                our_skip = our_m2 * th + our_c2;
                        	//our_skip = 0.1509 * th * th + 66.979 * th + 30.227;
                        else
                                //our_skip = our_m1 * th + our_c1;
                        	our_skip = 0.1509 * th * th + 66.979 * th + 30.227;
 			//printf(" skip %d th %f \n",our_skip,th);
			float our_predicted_response_time = getResponseTime(write_size,j,our_skip);
                        //printf("%f,%f,%f\n",j,our_predicted_response_time,getminResponseTime(write_size,j));
			
			int predicted_skip =  ( C + j ) * L;
//			predicted_skip = predicted_skip%L;
                        float predicted_response_time = getResponseTime(write_size,j,predicted_skip);
			
			printf("%f,%f,%f\n",j,getminResponseTime(write_size,j),getResponseTime(write_size,j,skip_distance));
                        
                        double min_resp_time = getminResponseTime(write_size,j);
                        double compress_resp_time = getResponseTime(write_size,j,skip_distance);

//
                        tot_count ++;
                        sum_deviation +=  ( compress_resp_time - min_resp_time );

//			printf("%f\n",getminResponseTime(write_size,j));
//			printf("%f\n",getResponseTime(write_size,j,skip_distance));
//			printf("%f\n",predicted_response_time);
//			printf(" For request size: %d and think time %f, actual min time %f and our time %f \n",write_size,j,getminResponseTime(write_size,j),getResponseTime(write_size,j,skip_distance));
//			printf(" Predicted skiip : %d Response time: %f\n",predicted_skip,predicted_response_time);
		}
	}
    }
    
  double mean_deviation = (sum_deviation/tot_count);
  printf(" After analysis: mean deviation = %f\n",mean_deviation);

}




void compressdata_1(float tolerance){

	int i;
	compressed_data_count = -1;
	//printf(" REached here \n ");
//	compressed_data[compressed_data_count].write_size = data[0].write_size;
//	compressed_data[compressed_data_count].think_begin = data[0].thinktime;
//	compressed_data[compressed_data_count].think_end = data[0].thinktime;
//	compressed_data[compressed_data_count].start_skip = -1;
//	compressed_data[compressed_data_count].end_skip = -1;

///	int current_write_size=data[0].write_size;
////    we need to analyze code for a given write_size what is the stuff we can do..
        int current_write_size = 4;
	//printf(" current_data_size %d\n",current_data_size);
        for(; current_write_size <= 4 ; current_write_size += 4){
			// new entry.
			compressed_data_count ++;
                       // compressed_data[compressed_data_count].write_size = data[i].write_size;
                        //compressed_data[compressed_data_count].think_begin = data[i].thinktime;
                       // compressed_data[compressed_data_count].think_end = data[i].thinktime;
                        compressed_data[compressed_data_count].start_skip = -1;
                        compressed_data[compressed_data_count].end_skip = -1;
                      //printf("adding a new entruy \n");

		for(i = 0; i < current_data_size; i ++){
			//	printf(" i: %d current_write_size %d x: %d thinktime %f \n",i,current_write_size,data[i].write_size,data[i].thinktime); 
	        	if(data[i].write_size == current_write_size){
				//// scope of getting data
				// find the range of skiupsr fes
				int start_skip=-1;
				int end_skip=-1;
				
				int j;
				//		printf("count %d\n",data[i].count);
				for( j = 0; j < data[i].count; j ++){
							if(start_skip == -1){
								if(data[i].responsetimes[j] < data[i].min + tolerance){
												start_skip = data[i].skipdists[j];
												end_skip = data[i].skipdists[j];
										}
							} else{
								//// make sure that u get consecutive data
								if(data[i].responsetimes[j] < data[i].min + tolerance)
									end_skip = data[i].skipdists[j];
								else
									break;
							}	
						}	

			//	printf(" size: %d think time %f start_skip %d end_skip %d \n",current_write_size,data[i].thinktime,start_skip,end_skip);			
			// here we have got start_skip and end_skip which are supposed to be reasonable for this think time.
			//// see if start_skip and end_skip
			if(compressed_data[compressed_data_count].start_skip == -1){
				// if it is -1. its the first entry

				compressed_data[compressed_data_count].start_skip = start_skip;
                        	compressed_data[compressed_data_count].write_size = data[i].write_size;
				compressed_data[compressed_data_count].end_skip = end_skip;
				compressed_data[compressed_data_count].think_begin = data[i].thinktime;
			        compressed_data[compressed_data_count].think_end = data[i].thinktime;

			} else { /// compare previous start
				/// first check whether its a disjoint set or not
				if(start_skip > compressed_data[compressed_data_count].end_skip
				|| compressed_data[compressed_data_count].start_skip > end_skip) 
				//// it is a disjoint set, handle it separately
					{
					  compressed_data_count ++; // add it as a new entry
					 compressed_data[compressed_data_count].start_skip = start_skip;
                                	 compressed_data[compressed_data_count].end_skip = end_skip;
                        		compressed_data[compressed_data_count].write_size = data[i].write_size;
                                	 compressed_data[compressed_data_count].think_begin = data[i].thinktime;
                                	 compressed_data[compressed_data_count].think_end = data[i].thinktime;
					}
				else{
					if(compressed_data[compressed_data_count].start_skip < start_skip)
						compressed_data[compressed_data_count].start_skip = start_skip;
					if(compressed_data[compressed_data_count].end_skip > end_skip)
                                                compressed_data[compressed_data_count].end_skip = end_skip;

				       compressed_data[compressed_data_count].think_end = data[i].thinktime; 
				}
 

				}
			}//// matches data[i].size == current_..
		}/// second for		


	}// first for


   } 






int main(int argc, char **argv){

double avg_service_time = 0;
double min_service_time = 0;
double max_service_time = 0;

int size_write = -1;
int size_skip = -1;
float us_sleep = -1;
int repeat = 0;
int log_offset = 0;

double total_data_written = 0;
double total_write_time = 0;
double bandwidth;
double total_bench_time = 0;


// printf("Results indiv_write %d KB skip %d KB ms_sleep %f ms repeat %d total_data_written %f MB total_write_time %f s total_bench_time %f s bandwidth %f MB/s log_offset %d avg_service_time %f ms min_service_time %f ms max_service_time %f ms\n", size_write, size_skip, ((float)(us_sleep))/1000, repeat, total_data_written, total_write_time, total_bench_time, total_data_written/total_write_time, log_offset, avg_service_time, min_service_time, max_service_time);
char line[1000];
char garbage[50];
if(argc != 3){
	fprintf(stderr,"error: usage is ./compressdata file_name tolerance \n");
	exit(-1);
}
FILE *fp = fopen(argv[1],"r");

//// this code is going to build a table, for each 
///// write size and think time, what is the skip size for which the 
//// avg service time is minimized

double curr_min_avg_service_time;
int skip_distance;

int current_write_size;
float current_think_time;
int is_start = 1;

while(fgets(line,1000,fp) != NULL){
	if(strncmp(line,"Results",7)==0){
		sscanf(line,"Results indiv_write %d KB skip %d KB ms_sleep %f ms repeat %d total_data_written %lf MB total_write_time %lf s total_bench_time %lf s bandwidth %lf MB/s log_offset %d avg_service_time %lf ms min_service_time %lf ms max_service_time %lf ms",&size_write, &size_skip, &us_sleep, &repeat, &total_data_written, &total_write_time, &total_bench_time, &bandwidth, &log_offset, &avg_service_time, &min_service_time, &max_service_time);

		//printf("Results indiv_write %d KB skip %d KB ms_sleep %f ms repeat %d total_data_written %f MB total_write_time %f s total_bench_time %f s bandwidth %f MB/s log_offset %d avg_service_time %f ms min_service_time %f ms max_service_time %f ms\n", size_write, size_skip, us_sleep, repeat, total_data_written, total_write_time, total_bench_time, bandwidth, log_offset, avg_service_time, min_service_time, max_service_time);

	/*	if(is_start == 1){ /// first line being read
			current_write_size = size_write;
			current_think_time = us_sleep;
			curr_min_avg_service_time = avg_service_time;
			skip_distance = size_skip;
			is_start = 0;
		}
		else {

            	if(current_write_size != size_write || current_think_time != us_sleep ){ /// new set of input
			// print ur result so far.

			 printf(" think_time %f request_size %d : skip distance : %d service time: %f \n",current_think_time, current_write_size, skip_distance,curr_min_avg_service_time);
			// load new set of input

			current_write_size = size_write;
			current_think_time = us_sleep;
			curr_min_avg_service_time = avg_service_time;
			skip_distance = size_skip;

			} else {			
					if(avg_service_time < curr_min_avg_service_time ) {
					curr_min_avg_service_time = avg_service_time;
					skip_distance = size_skip;

				}

				
			}
			
		   } /// end of else of  is_start
	*/

	/// first step is to insert data. we will apply various techniques to compress this data, including equation fitting etc.
	/// and examine the accuracy
	//		void insertdata(int write_size,float thinktime, int skipdistance, double responsetime){
			
			insertdata(size_write,us_sleep,size_skip,avg_service_time);
		
		
		} //// end of if(strcmp

	}/// while

     //printf(" think_time %f request_size %d : skip distance : %d service time: %f \n",current_think_time, current_write_size, skip_distance,curr_min_avg_service_time);

	printf(" total number of entries is %d \n",current_data_size);

//	printdata();
        
	float f ;
	f = atoi(argv[2])/100.0;
//	printf("%f\n",f);
	compressdata_1(f);
	printf(" Compressed data count entries %d \n",compressed_data_count);
        //printcompressed_data();
        printf(" compression %f\n",(current_data_size/(compressed_data_count * 1.0)));

	//// analyze compressed data

	analyzecompressed_data();	
//	fitcurve(f);
//	coarseDataAnalysis();
}
